﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Net;

namespace ukol1
{
    public partial class Form1 : Form
    {
        //kolekce policek
        Dictionary<Bod, plocha> panelColl = new Dictionary<Bod, plocha>();
        //id protokolu
        long protokol;
        private string host = "http://localhost:8000/";
        string Pohyby="";
        string OdUziv = "";
        public Form1()
        {
            Application.ThreadException += new System.Threading.ThreadExceptionEventHandler(Application_ThreadException);
            
            InitializeComponent();
            //vyžádá mapu
            string returned ="";
            using (WebClient client = new WebClient())
            {
               
                returned = client.DownloadString(host+"start");
            }
            long.TryParse(NewGame(returned), out protokol);
        }

        void Application_ThreadException(object sender, System.Threading.ThreadExceptionEventArgs e)
        {
            MessageBox.Show("Omlouváme se za chybu aplikace", "Nastala chyba");
        }
        //místo s pokladem
        Bod poklad;
        //nová hra
        string NewGame(string retezec)
        {
            string[] lines = retezec.Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);
            List<string> Map = new List<string>();
            for (int i = 1; i <= 20; i++)
            {
                Map.Add(lines[i]);
            }
            DrawPlocha(Map.ToArray());
            Pohyby = lines[22];
            textBox1.Text = Pohyby;
            textBox2.Text = "";
            OdUziv = "";
            textBox2.Enabled = true;
            NastavRobota(lines[21]);
            return lines[0];

        }
        //zjišťuje, kolik zbývá možností 
        public void go(char jak)
        {
            string add = "";
            int i=0;
            foreach (char znak in Pohyby)
            {
                if (znak == jak && add == "")
                {
                    Pohyby = Pohyby.Remove(i, 1);
                    switch (jak)
                    {
                        case 'L':
                            add = "L";
                            break;
                        case 'R':
                            add = "R";
                            break;
                        case '1':
                            add = "1";
                            break;
                        case '2':
                            add = "2";
                            break;
                        case '3':
                            add = "3";
                            break;
                        case 'Z':
                            add = "Z";
                            break;
                    }
                }
                i++;
            }
            OdUziv += add;
            textBox2.Text = OdUziv;
            textBox1.Text = Pohyby;
        }

        private void EndGame()
        {
            MessageBox.Show("Jste zničen");
        }
        //čte příkazy
        //pokud prubeh je true
        //čte se zpožděním
        private void ReadCommands(string Commands, bool prubeh=false)
        {
            foreach (char jak in Commands)
            {
                switch (jak)
                {
                    case 'L':
                        if (robo.smer == 1) robo.smer = 4;
                        else
                            robo.smer -= 1;
                        break;
                    case 'R':
                        if (robo.smer == 4) robo.smer = 1;
                        else
                            robo.smer += 1;
                        break;
                    case '1':
                        //udělá 1 krok
                        HniRobotem();
                        break;
                    case '2':
                        //udělá 2 kroky
                        HniRobotem();
                        HniRobotem();
                        break;
                    case '3':
                        //udělá 3 kroky
                        HniRobotem();
                        HniRobotem();
                        HniRobotem();
                        break;
                    case 'Z':
                        //reverzuje robote
                        if (robo.smer == 1) robo.smer = 4;
                        else
                            robo.smer -= 1;
                        if (robo.smer == 1) robo.smer = 4;
                        else
                            robo.smer -= 1;
                        //udělá krok
                        HniRobotem();
                        //reverzuje zpátky
                        if (robo.smer == 1) robo.smer = 4;
                        else
                            robo.smer -= 1;
                        if (robo.smer == 1) robo.smer = 4;
                        else
                            robo.smer -= 1;
                        break;
                }
                if(prubeh)
                System.Threading.Thread.Sleep(1000);
            }
            string returned = "";
            using (WebClient client = new WebClient())
            {

                returned = client.DownloadString(host+"kolo?id="+protokol+"&pohyby="+OdUziv);
            }
            if (returned.Substring(0, 12) == "Vyhrali jste") MessageBox.Show("Vyhral jste");
            else
                if (!(returned.Substring(0, 5) == "Chyba"))
                {
                    //nová hra
                    string[] lines = returned.Split(new string[] { Environment.NewLine }, StringSplitOptions.RemoveEmptyEntries);
                    List<string> Map = new List<string>();
                    for (int i = 1; i <= 20; i++)
                    {
                        Map.Add(lines[i]);
                    }
                    Pohyby = lines[22];
                    textBox1.Text = Pohyby;
                    textBox2.Text = "";
                    textBox2.Enabled = true;
                    OdUziv = "";
                    NastavRobota(lines[21]);
                }
            timer1.Enabled = false;
        }
        //nastaví počáteční pozici robota
        void NastavRobota(string hlavicka)
        {
            List<string> RetColl = (hlavicka.Split(new char[] { ' ' })).ToList<string>();

            robo.Move(new Bod((int.Parse(RetColl[0])) - 1, (int.Parse(RetColl[0]) - 1)));
            switch (RetColl[2])
            {
                case "N": robo.smer = 1; break;
                case "R": robo.smer = 2; break;
                case "D": robo.smer = 3; break;
                case "L": robo.smer = 4; break;
            }
        }
        //pokne s robotem
        void HniRobotem()
        {
            Bod novy = Hni();
            bool tristi = true;
            foreach (Bod bod in panelColl.Keys)
            {
                if (bod.X == novy.X && bod.Y == novy.Y)
                {
                    tristi = false;
                }
            }
            if (tristi) { EndGame(); return; }
            if (panelColl[novy].typ == plocha.plochaT.dira) EndGame();
            if (panelColl[novy].typ == plocha.plochaT.volno) robo.Move(novy);

            
        }
        //zjistí novou pozici
        Bod Hni()
        {
            switch (robo.smer)
            {
                case 1:
                    return new Bod(robo.poloha.X, robo.poloha.Y - 1);
                    break;
                case 2:
                    return new Bod(robo.poloha.X + 1, robo.poloha.Y);
                    break;
                case 3:
                    return new Bod(robo.poloha.X, robo.poloha.Y + 1);
                    break;
                case 4:
                    return new Bod(robo.poloha.X - 1, robo.poloha.Y);
                    break;

            }
            return new Bod(0, 0);
        }
        //vykreslí herní plochu
        public void DrawPlocha(string[] text)
        {
            int Y = 0;
            foreach (string radek in text)
            {
                int X = 0;
                foreach (char znak in radek)
                {
                    plocha nova = new plocha(new Bod(X, Y));
                    nova.typ = plocha.plochaT.volno;
                    place.Controls.Add(nova);
                    nova.Name = "plochapro" + X.ToString() + Y.ToString();
                    panelColl.Add(new Bod(X,Y),nova);
                    switch (znak)
                    {
                        case '.':
                            nova.typ = plocha.plochaT.volno;
                            break;
                        case 'X':
                            nova.typ = plocha.plochaT.zed;
                            break;
                        case '#':
                            nova.typ = plocha.plochaT.dira;
                            break;
                        case '$':
                            nova.typ = plocha.plochaT.poklad;
                            poklad = nova.poloha;
                            break;
                        default:
                            textBox2.Text.Remove(textBox2.Text.Length - 1);
                            break;
                    }
                    X++;
                }
                Y++;
            }
          }

        private void Form1_MouseUp(object sender, MouseEventArgs e)
        {

        }

        private void Form1_KeyPress(object sender, KeyPressEventArgs e)
        {
            go(e.KeyChar);
        }

        private void Form1_KeyDown(object sender, KeyEventArgs e)
        {

        }

        private void Form1_KeyUp(object sender, KeyEventArgs e)
        {

        }

        private void label1_Click(object sender, EventArgs e)
        {

        }

        private void textBox2_TextChanged(object sender, EventArgs e)
        {
            if(textBox2.Text.Length!=0)go(textBox2.Text.Last<char>());
            textBox2.Enabled = !(textBox2.Text.Length >= 5);
        }

        private void button1_Click(object sender, EventArgs e)
        {
            ReadCommands(OdUziv);
        }

        private void button2_Click(object sender, EventArgs e)
        {
            //zahájí novou hru
            place.Controls.Clear();
            panelColl.Clear();
            place.Controls.Add(robo);
            //
            string returned = "";
            using (WebClient client = new WebClient())
            {

                returned = client.DownloadString(host + "start");
            }
            long.TryParse(NewGame(returned), out protokol);
        }

        private void button3_Click(object sender, EventArgs e)
        {
            (new HelpBox()).ShowDialog();
        }

        private void button4_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
            iPrikaz = 0;
        }
        int iPrikaz = 0;
        private void timer1_Tick(object sender, EventArgs e)
        {
            if (iPrikaz < 6)
            {
                ReadCommands(OdUziv, true);
          
                iPrikaz++;
            }
        }
    }
}
